import QtQuick 2.7
import QtQuick.Controls 2.0
import QtQuick.Layouts 1.0

import "views" as Views

Item {
	property alias unitCodesSwitch: unitCodesSwitch
	property alias unitsTree: unitsTree
	property alias resetButton: resetButton
	property alias unitFilterText: unitFilterText

	//property alias busyIndicator: busyIndicator
	ColumnLayout {
		id: searchLayout
		spacing: 1
		anchors.bottomMargin: 40
		anchors.fill: parent

		RowLayout {
			id: quickSearchLayout
			width: 100
			height: 100
			spacing: 1

			TextField {
				id: quickSearchText
				Layout.fillWidth: true
				placeholderText: qsTr("Быстрый поиск")
			}

			Button {
				id: quickSearchButton
				text: qsTr("Поиск")
			}
		}

		RowLayout {
			id: middle0Layout
			width: 100
			height: 100

			Switch {
				id: unitCodesSwitch
				text: qsTr("коды подр.")
			}

			Button {
				id: advancedSearchButton
				text: "Расширенный поиск"
				Layout.fillWidth: true
			}
		}

		RowLayout {
			id: middle1Layout
			width: 100
			height: 100

			Button {
				id: resetButton
				width: 75
				text: qsTr("Сбросить")
			}

			TextField {
				id: unitFilterText
				placeholderText: qsTr("Фильтр подразделений")
				Layout.fillWidth: true
			}

		}

		Views.UnitsTree {
			id: unitsTree
			Layout.fillHeight: true
			Layout.fillWidth: true
		}

	}

	Item {
		id: pageNameLayout
		height: 40
		anchors.right: parent.right
		anchors.rightMargin: 0
		anchors.left: parent.left
		anchors.leftMargin: 0
		anchors.bottom: parent.bottom
		anchors.bottomMargin: 0

		Text {
			id: pageName
			text: qsTr("Поиск")
			font.pixelSize: parent.width > 300 ? 24 : 12
			verticalAlignment: Text.AlignVCenter
			horizontalAlignment: Text.AlignHCenter
			renderType: Text.QtRendering
			font.capitalization: Font.MixedCase
			anchors.fill: parent
		}
	}
}
