#include <QDebug>

#include "Voip.h"

Voip::Voip() : APIBase ( 0 )
{
}

QNetworkReply *Voip::getUnits()
{
	QUrl url = QUrl ( baseUrl() + "/units.json" );
	QUrlQuery query;
	query.addQueryItem ( "limit", "65530" );
	query.addQueryItem ( "renderFilter", "units" );
	url.setQuery ( query.query() );
	//qDebug() << url.url();
	QNetworkReply *reply = get ( url );
	return reply;
}

QNetworkReply *Voip::getUnitsTree()
{
	QUrl url = QUrl ( baseUrl() + "/subscribers/me.json" );
	QUrlQuery query;
	query.addQueryItem ( "limit", "65530" );
	query.addQueryItem ( "renderFilter", "units_roots" );
	query.addQueryItem ( "forceFullView", "true" );
	query.addQueryItem ( "forceUnitsTreePrepareSubscribersForRender", "true" );
	url.setQuery ( query.query() );
	//qDebug() << url.url();
	QNetworkReply *reply = get ( url );
	return reply;
}

QNetworkReply *Voip::getUnit ( QString codeStr )
{
	QUrl url = QUrl ( baseUrl() + "/units/" + codeStr + ".json" );
	QUrlQuery query;
	query.addQueryItem ( "renderFilter", "unit_selected" );
	url.setQuery ( query.query() );
	//qDebug() << url.url();
	QNetworkReply *reply = get ( url );
	return reply;
}

QVariantList Voip::getVariantList ( QByteArray bytes )
{
	//qDebug() << "getVariantList(): " << bytes;
	//QString str = QString::fromUtf8 ( bytes.data(), bytes.size() );
	QJsonParseError parseError;
	QJsonDocument document = QJsonDocument::fromJson ( bytes, &parseError );

	if ( parseError.error != QJsonParseError::NoError ) {
		qDebug() << parseError.errorString();
	}

	QJsonObject response = document.object();
	QString requestString = response["request"].toString();
	// getting "renderFilter" value
	QUrl request = QUrl ( requestString );
	QUrlQuery query = QUrlQuery ( request.query() );
	QString renderFilter = query.queryItemValue ( "renderFilter" );
	//qDebug() << "renderFilter == " << renderFilter;
	// getting the result array
	QJsonArray jsonArray = response[renderFilter].toArray();
	QVariantList result = jsonArray.toVariantList();
	//qDebug() << "getVariantList(): " << result;
	return result;
}
