import QtQuick 2.7
import QtQuick.Controls 2.0
import QtQuick.Layouts 1.0

import "api" as API
import "models" as Models
import "views" as Views
import "helpers" as Helpers

ApplicationWindow {
	id: app

	visible: true
	width: 640
	height: 480
	title: qsTr("IP-телефония НИЯУ МИФИ")

	property alias unitsTree: searchPage.unitsTree

	API.Voip {id: voipAPI}
	Models.Unit {
		id: unitModel
		onLoadingStatusChanged: {
			unitsTree.considerLoadingStatusChanged(loadingStatus)
		}
		onSelectionChanged: {

		}
	}
	Models.Subscriber {
		id: subscriberModel
	}

	Helpers.MyPopup {
		id: popup
	}

	SwipeView {
		id: swipeView
		anchors.fill: parent
		currentIndex: tabBar.currentIndex

		Search {
			id: searchPage
			unitsTree.itemModel: unitModel
			onUnitSelected: {
				dataPage.showUnit.unitIndex = unitsTree.currentIndex
				swipeView.setCurrentIndex(1)
			}
		}

		Data {
			id: dataPage

			showUnit.unitModel: unitModel

			onReturnToSearch: {
				swipeView.setCurrentIndex(0)
			}
		}

		Settings {
			id: settingsPage
		}

		VirtualPhone {
			id: virtualPhonePage
		}

		AddressBook {
			id: addressBookPage
		}

		/*Chat {
			id: chatPage
		}*/
	}

	footer: TabBar {
		id: tabBar
		currentIndex: swipeView.currentIndex
		TabButton {
			id: searchPageButton
			text: qsTr("Поиск")
		}
		TabButton {
			id: dataPageButton
			text: qsTr("Данные")
		}
		TabButton {
			text: qsTr("Настройки")
		}
		TabButton {
			text: qsTr("Вирт. телефон")
		}
		TabButton {
			text: qsTr("Адресная книга")
		}
		/*TabButton {
			text: qsTr("Чат")
		}*/
	}
}
