#include "Appointment.h"

Appointment::Appointment ( QObject *parent ) : AbstractJsonRestListModel ( parent )
{
//	connect(this, SIGNAL(itemChanged(RestItem*)), this, SLOT(setIsClickableOnChange(RestTreeItem*)));
}

/*void Appointment::setIsClickableOnChange( RestItem *item )
{
	Q_UNUSED(item)
}

QVariantList Appointment::getVariantList ( QByteArray bytes )
{
	return static_cast<Voip *> ( apiInstance() )->getVariantList ( bytes );
}
*/
/*
QVariantMap Appointment::preProcessItem ( QVariantMap item )
{
	Q_UNUSED(item)
	return QVariantMap();
}
*/
QNetworkReply *Appointment::fetchMoreImpl ( const QModelIndex &parent )
{
	Q_UNUSED ( parent )
	qFatal("Called fetchMoreImpl() of Appointment model");
	return NULL;
}

QNetworkReply *Appointment::fetchDetailImpl ( QString id )
{
	Q_UNUSED(id)
	qFatal("Called fetchMoreImpl() of Appointment model");
	return NULL;
}

bool subscriberLessFunc(const QVariant &subscriberA, const QVariant &subscriberB)
{
	unsigned int posIdA = subscriberA.toMap()["Pos"].toInt();
	unsigned int posIdB = subscriberB.toMap()["Pos"].toInt();
	return posIdA < posIdB;
}
\
QVariantList Appointment::subscribers() const
{
	const int count = this->count();

	//qDebug() << "count == " << count;

	QVariantList subscribers;

	if (count == 0) {
		return subscribers;
	}

	// Getting the subscribers list

	QVariantMap subscribersMap;
	QString unitCodeStrFirst = "";
	QVariantMap unit;

	for (int row = 0; row < count; row++) {
		QVariantMap appointment = this->at(row).object();
		QString unitCodeStr     = appointment.value("UnitKey").toString();
		QVariantMap subscriber  = appointment.value("Subscriber").toMap();

		if (unitCodeStrFirst == "") {
			QVariant unitV = appointment.value("Unit");
			if (unitV.isValid()) {
				unit = unitV.toMap();
			}
			unitCodeStrFirst = unitCodeStr;
		}

		if (unitCodeStr != unitCodeStrFirst) {
			unit = QVariantMap();
		}

		//qDebug() << "row == " << row << "; " << "appointment == " << appointment << "; " << "subscriber == " << subscriber;

		QVariant subscriberKey = subscriber.value("Key");
		if (!subscriberKey.isValid()) {
			//qDebug() << "!stfCardId.isValid(): " << appointment;
			//subscriberKey = 0;
			continue;
		}

		QVariantList subscriberAppointments = QVariantList();
		subscriberAppointments.append(appointment);

		QVariant oldSubscriberV = subscribersMap.value(subscriberKey.toString());
		if (oldSubscriberV.isValid()) {
			QVariantMap oldSubscriber = oldSubscriberV.toMap();
			subscriberAppointments.append(oldSubscriber.value("Appointments").toList());
		}

		subscriber["Appointments"] = subscriberAppointments;

		subscribersMap[subscriberKey.toString()] = subscriber;
	}

	//qDebug() << "subscribersMap == " << subscribersMap;
	subscribers = subscribersMap.values();

	// Sorting

	if (unit != QVariantMap()) {
		QList<QVariant> orderList = unit["AppointmentsOrder"].toList();
		QMap<int, int> orderMap;

		int posId = 0;
		QListIterator<QVariant> orderIter(orderList);
		while (orderIter.hasNext()) {
			int stfCardId = orderIter.next().toInt();
			orderMap[stfCardId] = posId++;
		}

		QMutableListIterator<QVariant> iter(subscribers);
		while (iter.hasNext()) {
			QVariant &subscriberP = iter.next();
			QVariantMap subscriber = subscriberP.toMap();
			unsigned int minPosId = ~0;

			QList<QVariant> subscriberAppointments = subscriber["Appointments"].toList();
			QListIterator<QVariant> appointmentIter(subscriberAppointments);
			while (appointmentIter.hasNext()) {
				QVariantMap appointment = appointmentIter.next().toMap();
				int stfCardId = appointment["StfCardId"].toInt();
				QVariant posIdV = orderMap[stfCardId];
				if (posIdV.isValid()) {
					unsigned int posId = posIdV.toInt();
					if (posId < minPosId) {
						minPosId = posId;
					}
				}
			}

			subscriber["Pos"] = minPosId;
			subscriberP = subscriber;
		}
		std::sort(subscribers.begin(), subscribers.end(), subscriberLessFunc);
	}

	// Finish

	return subscribers;
}
