#include "Unit.h"

Unit::Unit ( QObject *parent ) : AbstractJsonRestTreeModel ( parent )
{
	//qDebug() << "Unit::Unit()";
	connect(this, SIGNAL(itemChanged(RestTreeItem*)), this, SLOT(setIsClickableOnChange(RestTreeItem*)));
}

void Unit::setIsClickableOnChange( RestTreeItem *item )
{
	bool isClickable = item->value("HasSubscribers").isValid();
	//qDebug() << "Unit::setIsClickableOnChange(): " << item << ": " << isClickable;
	item->setIsClickable(isClickable);
}

QVariantList Unit::getVariantList ( QByteArray bytes )
{
	return static_cast<Voip *> ( apiInstance() )->getVariantList ( bytes );
}
/*
QVariantMap Unit::preProcessItem ( QVariantMap item )
{
	//qDebug() << "preProcessItem(): " << item;
	return item;
}
*/
QNetworkReply *Unit::fetchMoreImpl ( const QModelIndex &parent )
{
	Q_UNUSED ( parent )
	return static_cast<Voip *> ( apiInstance() )->getUnitsTree();
}

QNetworkReply *Unit::fetchDetailImpl ( QString id )
{
	return static_cast<Voip *> ( apiInstance() )->getUnit ( id );
}

bool preModelEndInsertRows_setKnownValues( RestTreeItem *unit, void *arg ) {
	Q_UNUSED(arg)

	QList<QVariant> appointments = unit->value("AppointmentsForRender").toList();

	QMutableListIterator<QVariant> appointmentsIter( appointments );
	while( appointmentsIter.hasNext() )
	{
		QVariant &appointment = appointmentsIter.next();
		QVariantMap appointmentMap = appointment.toMap();
		appointmentMap["Unit"] = unit->object();
		appointment = appointmentMap;
	}

	unit->setFieldValue("AppointmentsForRender", appointments);
	return true;
}

void Unit::preModelEndInsertRows () {
	this->callRecursive(preModelEndInsertRows_setKnownValues, NULL);

	return;
}

/*bool Unit::doInsertItems(const QVariantList &values)
{
    //prepare vars
    int insertFrom  = rowCount();
    int insertCount = rowCount()+values.count()-1;

    //check if we need to full reload
    if (this->loadingStatus() == LoadingStatus::FullReloadProcessing) {
        reset();
        insertFrom  = rowCount();
        insertCount = values.count()-1;
    }

    //check for assertion or empty data
    if (insertCount < insertFrom) { insertCount = insertFrom; }

    if (insertCount == 0) {
        setLoadingStatus(LoadingStatus::Error);
        qDebug() << "Nothing to insert! Please check your parser!" << count() << loadingStatus();
        return false;
    }

    //append rows to model
    beginInsertRows(this->index(rowCount(), 0), insertFrom, insertCount);

    QListIterator<QVariant> i(values);
    while (i.hasNext()) {
        RestItem item = createItem(i.next().toMap());
        if (item.value("ParentsCodeStr").isValid()) {
            //item.m_object.Node.setParent(m_items[0].m_object.Node);
            //continue;
        }
        append(item);
    }

    return true;
}
*/
